# fichier -- a priori, fichiers textes
# 1) créer un fichier (écriture)

f=open('fichier_test','w') # ouverture en écriture write
f.write('un test\n')  # on va à la ligne
f.write('deuxième ligne ') # pas ici <--
f.write('la suite') # on écrit à la suite
f.close()  # ne pas oublier de fermer le fichier !

# 2) lire tout un fichier

f=open('fichier_test','r') # ouverture en lecture
a=f.read()    # place 'tout' le fichier dans une seule chaîne
print(repr(a))
f.close()

print('='*30)

# 3) lire ligne par ligne

f=open('fichier_test','r') # ouverture en lecture read
b=f.readline()
print(repr(b))
b=f.readline()
print(repr(b))
b=f.readline()
print(repr(b))  # on remarque la dernière ligne, chaîne vide
f.close()

# avec une boucle, on passe en revue le fichier

f=open('fichier_test','r') # ouverture en lecture
for ligne in f:
    print(repr(ligne))  
f.close()


print('='*30)

# attention on écrase le fichier avec 'w'

f=open('fichier_test','w') 
for i in range(10):
    f.write(str(i**3)+'\n')  # on écrit des chaînes
f.close()

f=open('fichier_test','r') # ouverture en lecture
for ligne in f:
    x=int(ligne) 
    print(f'double {2*x:4d}')
f.close()

print('='*30)

f=open('fichier_test','r') 
a=f.readlines() # place les lignes du fichier dans une liste
print(a)
f.close()

print('='*30)

# une alternative à close, utiliser 'with' , bonne pratique

with open('fichier_test','r') as f:
    b=f.readline()  # on lit une ligne, puis le reste
    print(b)
    b=f.read()
    print(b)  # <- pas besoin de fermer le fichier
   
print('='*30)    
   
# 4) lire/écrire/ajouter : 'append'

f=open('fichier_test','a') 
f.write('une nouvelle ligne\n')
f.write('on n\'a rien perdu')    # tiens ! un '
f.close()

f=open('fichier_test','r') 
a=f.readlines() # place les lignes du fichier dans une liste
print(a)
f.close()

# remarque on peut aussi utiliser des fichiers "binaires" 
